<?php
require_once 'system/setup.conf';
require_once 'warp/warplib/applet.inc';

class Warp_Routines_Applet extends Warp_Applet
{
    function Warp_Routines_Applet($caption = "Routines")
    {
        parent::__construct($caption);
        $this->routineBinary  = '/usr/local/minerva/bin/routine ';
    }

    function init(&$appMan)
    {
        parent::init($appMan);
    }

    function getDirectory()
    {
        return "routines";
    }

    function renderWindow(&$appMan)
    {
        $list = array();
        exec($this->routineBinary . " list", $list);

        $v = &$appMan->getView();
        $html = $v->createTableHeader();
        foreach($list as $entry) {
           $timeat = null;

           $matches = array();
           if (preg_match('/^\s*(\d+)\s+:\s+(.*)\s+at(.*)$/', $entry, $matches)) {
              $timeat = 'Usually run at ' . $matches[3];
           } else if (preg_match('/^\s*(\d+)\s+:\s+(.*)$/', $entry, $matches)) {
              $timeat = '';
           }

           if ($timeat !== null) {
              $link = $this->getAjaxLink("process.php?start=$matches[1]", 'Start Now');
              $info = $appMan->getAppletLink($this, 'info', $matches[1], 'Details');
              $html .= $v->createTableRow($matches[1], "<b>" . $matches[2] . "</b>", $link, $timeat, $info);
           }
        }

        $html .= $v->createTableFooter();

        $info = $appMan->queryParameter($this, 'info', 0);
        if ($info) {
            $html .= "<p>Full script for routine $info</p><p>";
            $list = array();
            exec($this->routineBinary . " info $info", $list);
            $html .= implode('<BR>', $list);
        }

        return $html;
    }
}

?>

