<?php
require_once 'system/setup.conf';
require_once 'system/utils.inc';

require_once 'warp/warplib/applet.inc';
require_once 'warp/warplib/appletutils.inc';
require_once 'warp/applets/browser/browser.inc';

include_once 'warp/conf/security.inc';

/*
Uses:

http://www.charliemouse.com/code/cambozola/

as discovered here:

http://www.lavrsen.dk/foswiki/bin/view/Motion/WebcamServer

Note:

You will normally need to open the localhost, so you config includes both:

webcam_port 8081
webcam_localhost off

And remember to open the port(s) on your router.

*/


class Warp_Security_Applet extends Warp_Browser_Applet
{

    function Warp_Security_Applet($caption = "Security", $rootpath = NULL, $mappedpath = NULL)
    {
    global $g_cameraList;

        parent::__construct($caption, $rootpath, $mappedpath);

        $this->cameraList = $g_cameraList;
    }

    function getDirectory()
    {
        return "security";
    }

    function init(&$appMan)
    {
        parent::init($appMan);

        $this->_isFullSize = false;
        $this->_markedFile = NULL;
        $this->_onlySWF = true;

        $store_it = $appMan->queryParameter($this, "archive");
        if ($store_it != "") {
           $this->_markedFile = &$this->_filelist[$store_it];
           $target = $this->_rootpath . "/archive/";
           $target .= str_replace('/', '_', $this->_markedFile->_url);
           $mkdir = dirname($target);

           @mkdir($mkdir, 0777, true);
           copy($this->_markedFile->_path, $target);
        }

        $view = $appMan->queryParameter($this, "view");
        if ($view != "") {
           $this->_markedFile = &$this->_filelist[$view];
        }
        return true;
    }

    function getCameraViews()
    {
       $html = "";

       foreach($this->cameraList as $cam) {
          $server = "http://" . $cam['ip'];
          $port = $cam['port'];

          $url = "$server:$port";

          $applet = $this->getPathStub() . "/cambozola.jar";
          $pane = '<applet code=com.charliemouse.cambozola.Viewer
    archive=' . $applet . ' width="320" height="240" style="border-width:1; border-color:gray; border-style:solid;"> <param name=url value="' . $url . '"> </applet> ';

          $html .= "<a href='$url' target='_new'>$url</a><br/>" . $pane . "<br/><br/>";
       }

       return $html;
    }


    function renderWindow(&$appMan)
    {
            $top = $this->getDirectoryBrowser($appMan, $this->_dir);
            $filepane = $this->getFilePane($appMan, 0);
            $dirpane = $this->getDirectoryPane($appMan, 0);
            $preview = $this->getCameraViews();
            $preview.= $this->getPreviewHTML($appMan, $this->_markedFile);
            $rhs = $appMan->getView()->split2V($filepane, $preview);
            return $top . $appMan->getView()->split2V($dirpane, $rhs);
    }

    function getPreviewHTML(&$appMan, $f)
    {
       if ($f) {
           $full = $f->getFilePathSystem();
           if (appletUtils::isImageFile($full)) {
               $image = file_get_contents($full);
               $imdata = base64_encode($image);
               $preview = '<img width="128" src="data:image/png;base64,' . $imdata . '">';
               return "<hr>$preview";
           }
       }

       return "";
    }

    function includeFile($fn) 
    {
        $path_parts = pathinfo($fn);
        $ext = $path_parts['extension'];

        if ($ext == "swf") {
            return true;
        }
        return false;
    }

    function renderFileLine($appMan, $f)
    {
       $full = $f->getFilePathSystem();
       $imageLink = $f->getRenderLine();

       if ($this->_onlySWF) {
          $imageLink .= "&nbsp;";
          $imageLink .= $appMan->getAppletLink($this, "archive", $f->_idx, "[archive]") . "<BR/>";

       } else if (appletUtils::isImageFile($full)) {
          $imageLink  = $appMan->getAppletLink($this, "view", $f->_idx, $f->_title);
       } else {
			$imageLink .= "<br/>";
		}

       return $imageLink;
    }

}

?>


