<?php
require_once 'zinc/zinclib/device.inc';
require_once 'zinc/conf/videostreamcontrol.conf';

class VideoStreamControl extends ZincDevice
{
    // System handling

    public static function isPlaying()
    {
        $result = self::cmd('isplaying');
        return (int)$result;
    }

    public static function getCurrentURL()
    {
        $result = self::cmd('geturl');
        return $result;
    }

    public static function getCurrentName()
    {
        $url = self::cmd("geturl");
        $url = $url['output'];
        $name = strrchr($url, "/");
        if ($name == FALSE) {
           return $url;
        }
        return substr($name, 1);
    }

    public static function getServerIP()
    {
        $result = self::cmd('getip');
        return $result;
    }

    public static function getServerPort()
    {
        $result = self::cmd('getport');
        return (int)$result;
    }

    protected static function cmd($cmd) 
    {
        $cmd = VideoStreamDevice::$binary." ".VideoStreamDevice::$device." ".$cmd;
        $result = parent::cmd($cmd); 
        return trim($result['output']);
    }

    // Control
    public static function playURL($url) 
    {
        return self::cmd("play $url");
    }
       
    public static function stop() 
    {
         self::cmd("stop");
    }
       
}

?>

